
#include <iostream>
#include <fstream>
#include <string>
#include <sstream>
#include <map>
#include "instructions.h"

#include "gotolexer.h"
#include "parser.hpp"

using namespace std;

int main(int argc, char** argv)
{
    if(argc < 2)
    {
        cerr << argv[0] << " needs a goto-sourcecode as parameter\n";
        return 1;
    }

    ifstream sourcefile(argv[1]);
    GotoProgram* program = NULL;

    GotoLexer lexer(sourcefile);
    yy::GotoParser parser(lexer, &program);
    parser.parse();


    if(program != NULL)
    {
        ExecutionContext context;
        context.InstructionPointer = 0;

        for(int i = 2; i < argc; i++)
        {
            int temp;
            stringstream s;
            s << argv[i];
            s >> temp;

            stringstream n;
            n << "arg" << (i-1);

            context.Variables[n.str()] = temp;
        }
        context.Variables["argc"] = context.Variables.size();

        program->Execute(&context);
        delete program;
        
        if(context.Variables.find("result") != context.Variables.end())
            cout << context.Variables["result"] << "\n";
        else
            for(map<string,int>::iterator i = context.Variables.begin(); i != context.Variables.end(); i++)
                cout << i->first << " = " << i->second << "\n";
    }


    return 0;
}

