
#include "instructions.h"
using namespace std;


    GotoInstruction::GotoInstruction()
    {
    }

    GotoInstruction::~GotoInstruction()
    {
    }

    
    

    GotoProgram::GotoProgram()
    {
    }
    
    GotoProgram::~GotoProgram()
    {
        for(vector<GotoInstruction*>::iterator i = Instructions.begin(); i != Instructions.end(); i++)
            delete *i;
    }
    
    void GotoProgram::Execute(ExecutionContext* context)
    {
        while(context->InstructionPointer >= 0
        && context->InstructionPointer < Instructions.size())
            Instructions[context->InstructionPointer]->Execute(this, context);
    }

    
    

    Jump::Jump(string Label)
        : GotoInstruction()
    {
        this->Label = Label;
    }

    Jump::~Jump()
    {
    }

    void Jump::Execute(GotoProgram* program, ExecutionContext* context)
    {
        context->InstructionPointer = program->JumpLabels[Label];
    }

    
    

    ConditionalJump::ConditionalJump(string Variable, int CmpNumber, string Label)
        : Jump(Label)
    {
        this->Variable = Variable;
        this->CmpNumber = CmpNumber;
    }

    ConditionalJump::~ConditionalJump()
    {
    }

    void ConditionalJump::Execute(GotoProgram* program, ExecutionContext* context)
    {
        int temp = 0;
        if(context->Variables.find(Variable) != context->Variables.end())
            temp = context->Variables[Variable];

        if(temp == CmpNumber)
            Jump::Execute(program, context);
        else
            context->InstructionPointer++;
    }


    

    Stop::Stop()
        : GotoInstruction()
    {
    }

    Stop::~Stop()
    {
    }

    void Stop::Execute(GotoProgram* program, ExecutionContext* context)
    {
        context->InstructionPointer = -1;
    }


    
    
    Assignment::Assignment(string DstVariable, string SrcVariable, int Added)
        : GotoInstruction()
    {
        this->DstVariable = DstVariable;
        this->SrcVariable = SrcVariable;
        this->Added = Added;
    }

    Assignment::~Assignment()
    {
    }

    void Assignment::Execute(GotoProgram* program, ExecutionContext* context)
    {
        int tmp = 0;
        if(context->Variables.find(SrcVariable) != context->Variables.end())
            tmp = context->Variables[SrcVariable];
        context->Variables[DstVariable] = tmp + Added;

        context->InstructionPointer++;
    }

